<?php

/**
 * Executing selected item for options
 * 
 * @since 2.4 
 */
function wpt_selected( $keyword, $gotten_value ){
    $current_config_value = get_option('wpt_configure_options');
    echo ( isset( $current_config_value[$keyword] ) && $current_config_value[$keyword] == $gotten_value ? 'selected' : false );
}

/**
 * For Configuration Page
 * 
 * @since 2.4
 */
function wpt_configuration_page(){
    //var_dump($_POST);
    if( isset( $_POST['data'] ) && isset( $_POST['reset_button'] ) ){
        $value = WOO_Product_Table::$default;
        //var_dump($value);
        update_option( 'wpt_configure_options', $value );
       
    }else if( isset( $_POST['data'] ) && isset( $_POST['configure_submit'] ) ){
        //configure_submit
        $value = ( is_array( $_POST['data'] ) ? $_POST['data'] : false );
        update_option( 'wpt_configure_options', $value);
    }
    $current_config_value = get_option('wpt_configure_options');

    //var_dump($current_config_value);
    ?>
    <div class="wrap wpt_wrap wpt_configure_page">
        <h2 class="plugin_name"><?php echo WOO_Product_Table::getName(); ?> <span class="plugin_version">v <?php echo WOO_Product_Table::getVersion(); ?></span> <a href="<?php echo admin_url('admin.php?page=woo-product-table'); ?>" style="font-size: 15px;">Go to <b>Shortcode Generator Page</b></a></h2>
        <hr>
        <h1>Configuration Default Value</h1>
        <div id="wpt_configuration_form" class="wpt_leftside">
            <div style="padding-top: 15px;padding-bottom: 15px;" class="fieldwrap wpt_result_footer">
                <form action="" method="POST">
                    <input name="data[plugin_version]" type="hidden" value="<?php echo WOO_Product_Table::getVersion(); ?>" style="">
                    <input name="data[plugin_name]" type="hidden" value="<?php echo WOO_Product_Table::getName(); ?>" style="">
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_custom_add_to_cart">Add to Cart Icon</label>
                        <select name="data[custom_add_to_cart]" id="wpt_table_custom_add_to_cart" class="wpt_fullwidth" >
                            <option value="add_cart_no_icon" <?php wpt_selected('custom_add_to_cart', 'add_cart_no_icon');?>>No Icon</option>
                            <option value="add_cart_only_icon" <?php wpt_selected('custom_add_to_cart', 'add_cart_only_icon');?>>Only Icon</option>
                            <option value="add_cart_left_icon" <?php wpt_selected('custom_add_to_cart', 'add_cart_left_icon');?>>Left Icon and Text</option>
                            <option value="add_cart_right_icon" <?php wpt_selected('custom_add_to_cart', 'add_cart_right_icon');?>>Text and Right Icon</option>
                        </select>
                    </div>
                    
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_sort_mini_filter">Mini Filter Sorting</label>
                        <select name="data[sort_mini_filter]" id="wpt_table_sort_mini_filter" class="wpt_fullwidth" >
                            <option value="0" <?php wpt_selected('sort_mini_filter', '0');?>>None</option>
                            <option value="ASC" <?php wpt_selected('sort_mini_filter', 'ASC');?>>Ascending</option>
                            <option value="DESC" <?php wpt_selected('sort_mini_filter', 'DESC');?>>Descending</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_sort_searchbox_filter">Search Box Sorting</label>
                        <select name="data[sort_searchbox_filter]" id="wpt_table_sort_mini_filter" class="wpt_fullwidth" >
                            <option value="0" <?php wpt_selected('sort_searchbox_filter', '0');?>>None</option>
                            <option value="ASC" <?php wpt_selected('sort_searchbox_filter', 'ASC');?>>Ascending</option>
                            <option value="DESC" <?php wpt_selected('sort_searchbox_filter', 'DESC');?>>Descending</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_thumbs_image_size">Thumbs Image Size <small>[Only Int]</small></label>
                        <input name="data[thumbs_image_size]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['thumbs_image_size']; ?>" id="wpt_table_thumbs_image_size" type="number" placeholder="Thumbnail size. eg: 56" min="16" max="" pattern="[0-9]*" inputmode="numeric">
                        <!--
                        <select name="data[thumbs_image_size]" id="wpt_table_thumbs_image_size" class="wpt_fullwidth" >
                            <option value="30" <?php wpt_selected('thumbs_image_size', '30');?>>30 x 30 px</option>
                            <option value="56" <?php wpt_selected('thumbs_image_size', '56');?>>56 x 56 px</option>
                            <option value="100" <?php wpt_selected('thumbs_image_size', '100');?>>100 x 100 px</option>
                            <option value="200" <?php wpt_selected('thumbs_image_size', '200');?>>200 x 200 px</option>
                            <option value="400" <?php wpt_selected('thumbs_image_size', '400');?>>400 x 400 px</option>
                            <option value="500" <?php wpt_selected('thumbs_image_size', '500');?>>500 x 500 px</option>
                            <option value="800" <?php wpt_selected('thumbs_image_size', '800');?>>800 x 800 px</option>
                        </select>
                        -->
                    </div>
                    
                    <!-- New at Version: 3.1 -->
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_thumbs_lightbox">Thumbs Image LightBox</label>
                        <select name="data[thumbs_lightbox]" id="wpt_table_thumbs_lightbox" class="wpt_fullwidth" >
                            <option value="1" <?php wpt_selected('thumbs_lightbox', '1');?>>Enable</option>
                            <option value="0" <?php wpt_selected('thumbs_lightbox', '0');?>>Disable</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_disable_product_link">Disable Product Link</label>
                        <select name="data[disable_product_link]" id="wpt_table_disable_product_link" class="wpt_fullwidth" >
                            <option value="1" <?php wpt_selected('disable_product_link', '1');?>>Yes</option>
                            <option value="0" <?php wpt_selected('disable_product_link', '0');?>>No</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_product_link_target">Product Link Open Type</label>
                        <select name="data[product_link_target]" id="wpt_table_disable_product_link" class="wpt_fullwidth" >
                            <option value="_blank" <?php wpt_selected('product_link_target', '_blank');?>>New Tab</option>
                            <option value="_self" <?php wpt_selected('product_link_target', '_self');?>>Self Tab</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_all_selected_direct_checkout">Direct Checkout Page[for Add to cart Selected]</label>
                        <select name="data[all_selected_direct_checkout]" id="wpt_table_all_selected_direct_checkout" class="wpt_fullwidth" >
                            <option value="no" <?php wpt_selected('all_selected_direct_checkout', 'no');?>>No</option>
                            <option value="yes" <?php wpt_selected('all_selected_direct_checkout', 'yes');?>>Yes</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_product_direct_checkout">Enable Quick Buy Button [Direct Checkout Page just after Added to cart for each product]</label>
                        <select name="data[product_direct_checkout]" id="wpt_table_product_direct_checkout" class="wpt_fullwidth" >
                            <option value="no" <?php wpt_selected('product_direct_checkout', 'no');?>>No</option>
                            <option value="yes" <?php wpt_selected('product_direct_checkout', 'yes');?>>Yes</option>
                        </select>
                        <p style="color: #0071a1;padding: 0;margin: 0;">Direct going to Checkout Page just after Added to cart for each product</p>
                    </div>
                    
                    <hr/>
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_disable_cat_tag_link">Disable <strong>[Categories and Tags]</strong> Link</label>
                        <select name="data[disable_cat_tag_link]" id="wpt_table_disable_product_link" class="wpt_fullwidth" >
                            <option value="1" <?php wpt_selected('disable_cat_tag_link', '1');?>>Yes</option>
                            <option value="0" <?php wpt_selected('disable_cat_tag_link', '0');?>>No</option>
                        </select>
                    </div>
                    
                    <hr>
                    <h3>Others</h3>
                    
                    <!-- Quick View Button Text -->
                    <div class="wpt_column">
                        <label for="wpt_table_quick_view_btn_text" class="wpt_label"><b>[Quick View]</b> - Button Text</label>
                        <input name="data[quick_view_btn_text]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['quick_view_btn_text']; ?>" id="wpt_table_quick_view_btn_text" type="text" placeholder="eg: Quick View">
                        <p style="color: #005082;padding: 0;margin: 0;">Only for <a target="_blank" href="https://wordpress.org/plugins/yith-woocommerce-quick-view/">YITH WooCommerce Quick View</a> Plugin</p>
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_load_more_text" class="wpt_label"><b>[Load More]</b> - Button Text</label>
                        <input name="data[load_more_text]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['load_more_text']; ?>" id="wpt_table_load_more_text" type="text" placeholder="Load More text write here">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_search_button_text" class="wpt_label"><b>[Search]</b> - Button Text</label>
                        <input name="data[search_button_text]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['search_button_text']; ?>" id="wpt_table_search_button_textt" type="text" placeholder="Search text write here">
                    </div>
                    
                    
                    <div class="wpt_column">
                        <label for="wpt_table_search_keyword_text" class="wpt_label"><b>[Search Keyword]</b> - Text</label>
                        <input name="data[search_keyword_text]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['search_keyword_text']; ?>" id="wpt_table_search_button_textt" type="text" placeholder="Search Keyword">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_loading_more_text" class="wpt_label"><b>[Loading..]</b> - Button Text</label>
                        <input name="data[loading_more_text]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['loading_more_text']; ?>" id="wpt_table_loading_more_text" type="text" placeholder="Loading.. text write here">
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_disable_loading_more">Disable <b>[Load More]</b> Button</label>
                        <select name="data[disable_loading_more]" id="wpt_table_disable_loading_more" class="wpt_fullwidth" >
                            <option value="load_more_hidden" <?php wpt_selected('disable_loading_more', 'load_more_hidden');?>>Yes</option>
                            <option value="normal" <?php wpt_selected('disable_loading_more', 'normal');?>>No</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_instant_search_filter">Instant Search Filter</label>
                        <select name="data[instant_search_filter]" id="wpt_table_instant_search_filter" class="wpt_fullwidth" >
                            <option value="1" <?php wpt_selected('instant_search_filter', '1');?>>Yes</option>
                            <option value="0" <?php wpt_selected('instant_search_filter', '0');?>>No</option>
                        </select>
                    </div>
                    
                    
                    <div class="wpt_column">
                        <label for="wpt_table_instant_search_textt" class="wpt_label"><b>[Instance Search]</b> - Text</label>
                        <input name="data[instant_search_text]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['instant_search_text']; ?>" id="wpt_table_instant_search_text" type="text" placeholder="Instance Search text write here">
                    </div>
                    <hr>
                    <div class="wpt_column">
                        <label class="wpt_label" for="wpt_table_yith_product_type">Quote Request Plugin's Type</label>
                        <select name="data[yith_product_type]" id="wpt_table_instant_search_filter" class="wpt_fullwidth" >
                            <option value="free" <?php wpt_selected('yith_product_type', 'free');?>>Free</option>
                            <option value="premium" <?php wpt_selected('yith_product_type', 'premium');?>>Premium</option>
                        </select>
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_yith_browse_list" class="wpt_label"><b>[Browse Quote list]</b> - text <span style="color: red;">Only for Premium YITH Quote Request Plugin</span></label>
                        <input name="data[yith_browse_list]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['yith_browse_list']; ?>" id="wpt_table_yith_add_to_quote_text" type="text" placeholder="Browse the list - text write here">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_yith_add_to_quote_text" class="wpt_label"><b>[Add to Quote]</b> - button text</label>
                        <input name="data[yith_add_to_quote_text]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['yith_add_to_quote_text']; ?>" id="wpt_table_yith_add_to_quote_text" type="text" placeholder="Add to Quote text write here">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_yith_add_to_quote_adding" class="wpt_label"><b>[Quote Adding]</b> - text</label>
                        <input name="data[yith_add_to_quote_adding]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['yith_add_to_quote_adding']; ?>" id="wpt_table_yith_add_to_quote_adding" type="text" placeholder="Adding text write here">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_yith_add_to_quote_added" class="wpt_label"><b>[Quote Added]</b> - text</label>
                        <input name="data[yith_add_to_quote_added]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['yith_add_to_quote_added']; ?>" id="wpt_table_yith_add_to_quote_added" type="text" placeholder="Quote Added text write here">
                    </div>
                    <hr>
                    <div class="wpt_column">
                        <label for="wpt_table_default_quantity" class="wpt_label">Default Quantity| Eg: 1</label>
                        <input name="data[default_quantity]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['default_quantity']; ?>" id="wpt_table_default_quantity" type="number" placeholder="Default Quantity Input here. eg: 1" min="0" max="" pattern="[0-9]*" inputmode="numeric">
                    </div>
                    
                    <hr>
                    <div class="wpt_column">
                        <label for="wpt_table_item" class="wpt_label">Item [for Singular]</label>
                        <input name="data[item]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['item']; ?>" id="wpt_table_item" type="text" placeholder="Item | for All selected Button">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_item" class="wpt_label">Item [for Plural]</label>
                        <input name="data[items]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['items']; ?>" id="wpt_table_item" type="text" placeholder="Item | for All selected Button">
                    </div>
                    
                    <h3>Message</h3>
                    <div class="wpt_column">
                        <label for="wpt_table_right_combination_message" class="wpt_label">Variations [Not available] Message</label>
                        <input name="data[right_combination_message]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['right_combination_message']; ?>" id="wpt_table_right_combination_message" type="text" placeholder="Not Available">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_right_combination_message_alt" class="wpt_label">[Product variations is not set Properly. May be: price is not inputted. may be: Out of Stock.] Message</label>
                        <input name="data[right_combination_message_alt]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['right_combination_message_alt']; ?>" id="wpt_table_right_combination_message_alt" type="text" placeholder="Product variations is not set Properly. May be: price is not inputted. may be: Out of Stock.">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_select_all_items_message" class="wpt_label">[Please select all items.] Message</label>
                        <input name="data[select_all_items_message]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['select_all_items_message']; ?>" id="wpt_table_select_all_items_message" type="text" placeholder="Please select all items.">
                    </div>
                    
                    
                    
                    <div class="wpt_column">
                        <label for="wpt_table_out_of_stock_message" class="wpt_label">[Out of Stock] Message</label>
                        <input name="data[out_of_stock_message]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['out_of_stock_message']; ?>" id="wpt_table_out_of_stock_message" type="text" placeholder="Out of Stock">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_no_more_query_message" class="wpt_label">[There is no more products based on current Query.] Message</label>
                        <input name="data[no_more_query_message]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['no_more_query_message']; ?>" id="wpt_table_out_of_stock_message" type="text" placeholder="There is no more products based on current Query.">
                    </div>
                    
 <!--
     'adding_in_progress'    =>  __( 'Adding in Progress', 'wpt_pro' ),
    'no_right_combination'    =>  __( 'No Right Combination', 'wpt_pro' ),
    'sorry_out_of_stock'    =>  __( 'Sorry! Out of Stock!', 'wpt_pro' ),
 
 -->
                    
                    
                    <div class="wpt_column">
                        <label for="wpt_table_out_of_stock_message" class="wpt_label">[ Adding in Progress ] Message</label>
                        <input name="data[adding_in_progress]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['adding_in_progress']; ?>" id="wpt_table_out_of_stock_message" type="text" placeholder="Adding in Progress">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_out_of_stock_message" class="wpt_label">[ No Right Combination ] Message</label>
                        <input name="data[no_right_combination]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['no_right_combination']; ?>" id="wpt_table_out_of_stock_message" type="text" placeholder="No Right Combination">
                    </div>
                    
                    <div class="wpt_column">
                        <label for="wpt_table_out_of_stock_message" class="wpt_label">[ Sorry! Out of Stock! ] Message</label>
                        <input name="data[sorry_out_of_stock]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['sorry_out_of_stock']; ?>" id="wpt_table_out_of_stock_message" type="text" placeholder="Sorry! Out of Stock!">
                    </div>
                    
                    <!-- New Added at Version 3.1 -->
                    <div class="wpt_column">
                        <label for="wpt_table_no_more_query_message" class="wpt_label">[There is no more products based on current Query.] Message</label>
                        <input name="data[no_more_query_message]" class="wpt_data_filed_atts" value="<?php echo $current_config_value['no_more_query_message']; ?>" id="wpt_table_out_of_stock_message" type="text" placeholder="There is no more products based on current Query.">
                    </div>
                    
                    
                    <hr>
                    <button type="submit" name="configure_submit" class="button-primary primary button btn-info">Submit</button>
                    <button type="submit" name="reset_button" class="button">Reset</button>
                    
                </form>
            </div>
            
            
            
        </div>
        <!-- Right Side start here -->
        <div class="wpt_rightside">
            <div class="wpt_right_side_in_wrapper" style="padding: 10px;">
                <div class="social_title_wrapper">
                    <h2 class="social_title"><img src="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/social/social.png"> Share on Social Network</h2>
                    <p>Your one share can be best GIFT for me.</p>
                    <div class="social_links">
                        <?php
                            $url_for_share =urlencode('https://codecanyon.net/item/woo-product-table-pro/20676867');
                        ?>  
                        <a href="http://www.facebook.com/sharer.php?u=<?php echo $url_for_share; ?>" title="Your Share, My best Gift" target="_blank">
                            <img src="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/social/facebook.png">
                        </a>
                        
                        <a href="http://twitter.com/share?text=<?php echo urlencode("Best #Quick_Order Plugin for #WooCommerce #Product #Table Pro - #WPTpro | #" . rand(88,2934)); ?>&url=<?php echo $url_for_share; ?>&via=codersaiful" title="Your Share, My best Gift" target="_blank">
                            <img src="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/social/twitter.png">
                        </a>
                        
                        <a href="https://plus.google.com/share?url=<?php echo $url_for_share; ?>&t=<?php echo urlencode("Best Quick Order Plugin for WooCommerce Product Table Pro"); ?>" title="Your Share, My best Gift" target="_blank">
                            <img src="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/social/google.png">
                        </a>
                        
                        <a href="http://www.linkedin.com/shareArticle?mini=true&url=<?php echo $url_for_share; ?>&title=<?php echo urlencode("Best Quick Order Plugin for WooCommerce Product Table Pro"); ?>" title="Your Share, My best Gift" target="_blank">
                            <img src="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/social/linkedin.png">
                        </a>
                        
                        <a href="http://www.reddit.com/submit?url=<?php echo $url_for_share; ?>&title=<?php echo urlencode("Best Quick Order Plugin for WooCommerce Product Table Pro"); ?>" title="Your Share, My best Gift" target="_blank">
                            <img src="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/social/reddit.png">
                        </a>
                        
                        <a href="https://mail.google.com/mail/u/0/?view=cm&fs=1&su=<?php echo urlencode("Best Quick Order Plugin for WooCommerce Product Table Pro"); ?>&body=<?php echo $url_for_share; ?>&ui=2&tf=1" title="Your Share, My best Gift" target="_blank">
                            <img src="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/social/gmail.png">
                        </a>
                        
                        
                    </div>
                    <small>Feel free to knock me Any time.</small>
                </div>
            </div>
            
            <div class="wpt_right_side_in_wrapper" style="padding: 10px;">
                <div class="need_help_wrapper">
                    <h1>Need Help?</h1>
                    <span>Email: <a href="https://mail.google.com/mail/u/0/?view=cm&fs=1&su=<?php echo urlencode("Need help for " . site_url()); ?>&body=<?php echo urlencode("Hey Saiful, I need help.\nNow I will explain my Issue.\n...________\n"); ?>&ui=2&tf=1&to=<?php echo urlencode("Saiful Islam<codersaiful@gmail.com>"); ?>" target="_top">Gmail Me <b>(codersaiful@gmail.com)</b></a></span>
                    <span>FB Group: <a target="_blank" href="https://www.facebook.com/groups/WPTpro/">Join to our Plugin Group</a></span>
                    <span>Skype: <a href="#">codersaiful</a></span>
                    <span>Facebook: <a target="_blank" href="https://www.facebook.com/messages/t/codersaiful" target="_blank">Facebook Message Me</a></span>
                    <span>Facebook: <a target="_blank" href="https://www.facebook.com/codersaiful" target="_blank">Facebook Profile</a></span>
                    <span>Youtube: <a href="https://www.youtube.com/playlist?list=PL__UrUIHRxdzupiUk2KKJloistwDMP28t" target="_blank">Youtube Playlist - Video Tutorial</a></span>
                </div>
            </div>
            <div class="wpt_right_side_in_wrapper" style="padding: 10px;">
                <div class="need_help_wrapper">
                    <h3><a target="_blank" href="https://www.facebook.com/groups/WPTpro/">Join FB Group</a></h3>
                </div>
            </div>
            <div class="wpt_right_side_in_wrapper" style="padding: 10px;">
                <div class="rate_us_wrapper">
                    <a href="https://codecanyon.net/downloads" target="_blank"><img class="rate_us_image" src="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/rate_us.png"></a>
                    <h1>It can take only 2 Minutes.</h1>
                    <h3><a href="<?php echo WOO_Product_Table::getPath('BASE_URL'); ?>images/rate_us_tutorial_2.jpg" target="_blank">See Screenshot</a></h3>
                </div>
            </div>
            
        </div>    
    </div>  
    
    <style>
        .tab-content{display: none;}
        .tab-content.tab-content-active{display: block;}
        .wpt_leftside,.wpt_rightside{float: left;}
        .wpt_leftside{
            width: 75%;
        }
        .break_space_large{display: block;visibility: hidden;height: 25px;background: transparent;}
        .break_space,.break_space_medium{display: block;visibility: hidden;height: 15px;background: transparent;}
        .break_space_small{display: block;visibility: hidden;height: 5px;background: transparent;}
        .wpt_rightside{width: 25%;}
        @media only screen and (max-width: 800px){
            .wpt_leftside{width: 100%;}
            .wpt_rightside{display: none !important;}
        }
        /*****For Column Moveable Item*******/
        ul#wpt_column_sortable li>span.handle{
            background-image: url('<?php echo WPT_BASE_URL . 'images/move.png'; ?>');
        }

    </style>
    <?php
}